from pyloadl import *
from string import join
from time import gmtime, strftime
from sys import exit

"""

  Read and Display Global History information

"""

query = ll_query(JOBS)
if not PyCObjValid(query):
  print "ll_query(): returns a NULL\n"
  exit(-1)

b = ll_set_request(query, QUERY_ALL, "", ALL_DATA)
if b != 0:
  print "ll_set_request(): error %d\n" % b
  exit(-1)

job, number, error = ll_get_objs(query, LL_HISTORY_FILE, "/home/loadl/spool/globalhist.200501031255")
if error != 0:
  print "ll_get_objs(): error %d\n" % error
  exit(-1)

while PyCObjValid(job):

  JobName = ll_get_data(job, LL_JobName)

  cred  = ll_get_data(job,  LL_JobCredential)
  owner = ll_get_data(cred, LL_CredentialUserName)

  sdate = ll_get_data(job, LL_JobSubmitTime)
  submit = ""
  if sdate != 0:
    sdate = gmtime(sdate)
    submit  = strftime("%m/%d %H:%M", sdate)

  steps = ll_get_data(job, LL_JobStepCount)
  step  = ll_get_data(job, LL_JobGetFirstStep)
	
  # Loop through all steps for this job

  while PyCObjValid(step):

    jclass = ll_get_data(step, LL_StepJobClass)
    nodes = ll_get_data(step, LL_StepNodeCount)
    geometry = ll_get_data(step, LL_StepTaskGeometry)
    tasks = ll_get_data(step, LL_StepTaskInstanceCount)
    taskspernode = ll_get_data(step, LL_StepTasksPerNodeRequested)
    reqnodes = ll_get_data(step, LL_StepTotalNodesRequested)
    tasksreq = ll_get_data(step, LL_StepTotalTasksRequested)

    print "----------------------------------------\n"
    print "Job Name        : %s" % JobName
    print "Owner           : %s" % owner
    print "Submitted       : %s" % submit
    print "Class           : %s" % jclass
    print "Steps           : %d" % steps
    print "Node Count      : %d" % nodes
    print "Geometry        : %s" % geometry
    print "Nodes Requested : %s" % reqnodes
    print "Tasks per Node  : %d" % taskspernode
    print "Tasks           : %d" % tasks
    print "Tasks Requested : %d" % tasksreq

    step = ll_get_data(job, LL_JobGetNextStep)

  job = ll_next_obj(query)

ll_free_objs(job)
ll_deallocate(query)

