from pyloadl import *
from sys import exit
from string import join

"""

   Displays information on the LoadLeveler cluster

"""

query = ll_query(MCLUSTERS)
if not PyCObjValid(query):
   print "ll_query(): returns NULL\n"
   exit(-1)

b = ll_set_request(query, QUERY_ALL, [""], ALL_DATA)
if b != 0:
   print  "ll_set_request(): error %d\n" % b
   exit(-1)

mcluster, num, error = ll_get_objs(query, LL_SCHEDD, "")
if error != 0:
   print  "ll_get_objs(): error %d\n" % error
   exit(-1)

while PyCObjValid(mcluster):

   # LL_MClusterAllowScaleAcrossJobs, /* int * : The boolean allow scale across jobs status for this multi cluster */
   # LL_MClusterMainScaleAcrossCluster, /* int * : The boolean main scale across cluster status for this multi cluster */

   print "-" * 60
   clustername = ll_get_data(mcluster, LL_MClusterName)
   print "\tCluster Name        : %s" %  clustername

   local = ll_get_data(mcluster, LL_MClusterLocal)
   print "\tCluster is local    : %s" %  bool(local)

   inport = ll_get_data(mcluster, LL_MClusterInboundScheddPort)
   print "\tInbound port        : %s" %  inport

   secport = ll_get_data(mcluster, LL_MClusterSecureScheddPort)
   print "\tSecure Schedd port  : %s" %  secport

   secmethod = ll_get_data(mcluster, LL_MClusterMulticlusterSecurity)
   if secmethod:
     print "\tCluster Security    : %s" %  secmethod

     ssllist = ll_get_data(mcluster, LL_MClusterSslCipherList)
     print "\tSSL cipher list     : %s" %  ssllist

   scalejobs = ll_get_data(mcluster, LL_MClusterAllowScaleAcrossJobs)
   print "\tScale across jobs   : %s" %  bool(scalejobs)

   scalecluster = ll_get_data(mcluster, LL_MClusterMainScaleAcrossCluster)
   print "\tScale across cluster: %s" %  bool(scalecluster)

   inhosts = ll_get_data(mcluster, LL_MClusterInboundHosts)
   print "\tInbound hosts       : %s" %  inhosts

   outhosts = ll_get_data(mcluster, LL_MClusterOutboundHosts)
   print "\tOutbound hosts      : %s" %  outhosts

   inusers = ll_get_data(mcluster, LL_MClusterIncludeUsers)
   print "\tInclude users       : %s" %  inusers

   excl_users = ll_get_data(mcluster, LL_MClusterExcludeUsers)
   print "\tExclude users       : %s" %  excl_users

   incl_groups = ll_get_data(mcluster, LL_MClusterIncludeGroups)
   print "\tInclude groups      : %s" %  incl_groups

   excl_groups = ll_get_data(mcluster, LL_MClusterExcludeGroups)
   print "\tExclude groups      : %s" %  excl_groups

   incl_class = ll_get_data(mcluster, LL_MClusterIncludeClasses)
   print "\tInclude class       : %s" %  incl_class

   excl_class = ll_get_data(mcluster, LL_MClusterExcludeClasses)
   print "\tExclude class       : %s" %  excl_class

   mcluster = ll_next_obj(query)

#
# Free up space allocated by LoadLeveler
#

ll_free_objs(query)
ll_deallocate(query)
